import DS, { ModelSchema } from 'ember-data';
import JSONSerializer from '@ember-data/serializer/json';
import Store from '@ember-data/store';
import { CollectionReference, DocumentReference, Firestore } from 'firebase/firestore';
interface Links {
    [key: string]: string;
}
interface ResourceHash {
    id: string;
    links: Links;
    [key: string]: string | Links | CollectionReference;
}
interface RelationshipDefinition {
    key: string;
    type: string;
    options: {
        buildReference?(db: Firestore, record: unknown): CollectionReference;
    };
}
declare type ModelClass = ModelSchema & {
    determineRelationshipType(descriptor: {
        kind: string;
        type: string;
    }, store: Store): string;
};
export default class CloudFirestoreSerializer extends JSONSerializer {
    extractRelationship(relationshipModelName: string, relationshipHash: DocumentReference): {
        id: string;
        type: string;
    } | Record<string, unknown>;
    extractRelationships(modelClass: ModelClass, resourceHash: ResourceHash): Record<string, unknown>;
    serializeBelongsTo(snapshot: DS.Snapshot, json: {
        [key: string]: string | null | DocumentReference;
    }, relationship: RelationshipDefinition): void;
    serialize(snapshot: DS.Snapshot, options: Record<string, unknown>): Record<string, unknown>;
}
declare module 'ember-data/types/registries/serializer' {
    export default interface SerializerRegistry {
        'cloud-firestore-modular': CloudFirestoreSerializer;
    }
}
export {};
